
Procedure.q getSegmentAmount()
  Protected n.q=1
  zweige=GetGadgetState(#C_A_use)+GetGadgetState(#C_B_use)+GetGadgetState(#C_C_use)
  For i=1 To Val(GetGadgetText(#S_tiefe))-1
    n+Pow(zweige,i)
  Next
  ProcedureReturn n
EndProcedure


Procedure help()
  s.s
  s+"F1..........Hilfe"+Chr(10)
  s+"Enter......berechnen/zeichnen"+Chr(10)
  s+"ESC.......Berechnung abbrechen"+Chr(10)
  s+""+Chr(10)
  s+"Bewegen Sie die Maus zum oberen Bildschirmrand um"+Chr(10)
  s+"zustzliche Einstellungen vorzunehmen:"+Chr(10)
  s+"- Winkel (setzen durch Mausklick)"+Chr(10)
  s+"- Segmente: mit Rechts-/Linksklick auf die Segmente des"+Chr(10)
  s+"   Balkens knnen Sie einzelne Tiefen-Ebenen beim"+Chr(10)
  s+"   Zeichnen auslassen"+Chr(10)
  s+"- Startpunkt (zum setzen des Sartpunktes klicken Sie)"+Chr(10)
  s+"   auf die Zeichenflche)"+Chr(10)
  s+"- Hintergrundfarbe"+Chr(10)
  s+""+Chr(10)
  s+"x Start...."+Chr(10)
  s+"y Start....Startpunkt, P(0,0) ist oben links"+Chr(10)
  s+"r Start.....Lnge des 1. Segments"+Chr(10)
  s+""+Chr(10)
  s+"watch.....aktiviert das Zeichnen whrend der Berechnung"+Chr(10)
  s+"               (langsamer)"+Chr(10)
  s+"Tiefe.......gibt an wie oft die Verzweigung wiederholt wird"+Chr(10)
  s+"Zufall......einfache Streuung"+Chr(10)
  s+""+Chr(10)
  s+""+Chr(10)
  s+"Es knnen maximal 3 Zweige aktiviert werden (A,B und C )."+Chr(10)
  s+"An dem Endpunkt jedes Segments verzweigt der Baum wieder"+Chr(10)
  s+"in die Anzahl der Zweige. Das 1. Segment hat die Lnge r"+Chr(10)
  s+"und den Winkel alpha wie im CONTROL-Fenster abgegeben."+Chr(10)
  s+""+Chr(10)
  s+"Der Winkel des folgenden Segments wird aus dem aktuellen"+Chr(10)
  s+"Winkel mithilfe des Winkelfaktors und des Winkelsummanden"+Chr(10)
  s+"errechnet:"+Chr(10)
  s+""+Chr(10)
  s+"neuer Winkel = akueller Winkel * (alpha*) + (alpha+)"+Chr(10)
  s+""+Chr(10)
  s+""+Chr(10)
  s+"analog dazu findet die Berechnung der Lnge statt:"+Chr(10)
  s+""+Chr(10)
  s+"neue Lnge = aktuelle Lnge * (r*) + (r+)"+Chr(10)
  If OpenWindow(#WinHelp, 100,100, 330,550, "Hilfe - fryctyl", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget| #PB_Window_TitleBar | #PB_Window_WindowCentered)
    CreateGadgetList( WindowID(#WinHelp) )
      TextGadget(#T_help, 20,20, WindowWidth(#WinHelp)-20,WindowHeight(#WinHelp)-20, s )
  Else
    MessageRequester("error", "openwindow() failed")
  EndIf
EndProcedure


Procedure frac(x.d, y.d, alpha.d, r.d)
  If kill_recursion
    ProcedureReturn
  EndIf
  blau=Int( 255*Sin(#PI*tiefenzaehler/tiefe/2) )
  color=RGB(rot,gruen,blau)
  tiefenzaehler+1
  segmentzaehler+1
  SetGadgetState(#PrgBr, segmentzaehler)
  If checkedZufall
    xnext.d= (0.995+Random(1)/100.0)* (x+r*Sin( (angle+alpha)*#PI/180.0) )
    ynext.d= (0.995+Random(1)/100.0)* (y-r*Cos( (angle+alpha)*#PI/180.0) )
  Else
    xnext.d= x+r*Sin( (angle+alpha)*#PI/180.0 )
    ynext.d= y-r*Cos( (angle+alpha)*#PI/180.0 )
  EndIf
  
  If tiefeVerlauf(tiefenzaehler-1)
    LineXY(x,y, xnext,ynext, color) ;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< segment pinnnseln
  EndIf

  If (segmentzaehler%80)=0
    If checkedWatch
      StopDrawing()
      SetGadgetState(#IG_img, hImg)
      StartDrawing( ImageOutput(#img) )
    EndIf
    If WindowEvent()=#PB_Event_Menu And EventMenu()=#ShCt_esc
      kill_recursion=1
    EndIf
  EndIf
  
  If tiefenzaehler<tiefe
    rot=rot+255/tiefe
    If checkedA : frac(xnext, ynext, alpha*A_alphaMult+A_alphaAdd, r*A_rMult+A_rAdd)
    EndIf
    
    rot=rot-255/tiefe
    gruen=Int(gruen+255/tiefe);
    If checkedB : frac(xnext, ynext, alpha*B_alphaMult+B_alphaAdd, r*B_rMult+B_rAdd)
    EndIf
    
    gruen=gruen-255/tiefe
    If checkedC : frac(xnext, ynext, alpha*C_alphaMult+C_alphaAdd, r*C_rMult+C_rAdd)
    EndIf
  EndIf
  
  tiefenzaehler=tiefenzaehler-1
  ;If tiefenzaehler<1 : ProcedureReturn : EndIf
EndProcedure


Procedure drawTiefeVerlauf()
  StartDrawing( ImageOutput( #Img_tiefeVerlauf) )
    If tiefe
      Box(0,0, ImageWidth(#Img_tiefeVerlauf),ImageHeight(#Img_tiefeVerlauf), $ff0000)
        For i=0 To tiefe
          If tiefeVerlauf(i)
            Box(3+i*(300.0/tiefe),2, 300/tiefe-3, 16, $ff4400)
          Else
            Box(3+i*(300.0/tiefe),2, 300/tiefe-3, 16, $aa0000)
          EndIf
        Next
    Else
      Box(0,0, ImageWidth(#Img_tiefeVerlauf),ImageHeight(#Img_tiefeVerlauf), $999999)
      Box(0+3,0+3, ImageWidth(#Img_tiefeVerlauf)-6,ImageHeight(#Img_tiefeVerlauf)-6, $aaaaaa)
    EndIf
  StopDrawing()
  SetGadgetState(#IG_tiefeVerlauf, ImageID(#Img_tiefeVerlauf))
EndProcedure


Procedure drawAngle()
  StartDrawing( ImageOutput(#Img_angle) )
    Box(0,0,50,50, $ff0000) ;$e0dfe3
    Box(2,2,50-4,50-4, $aa0000)
    Circle(25,25, 22, $dd2200)
    Circle(25,25, 20, $ee3300)
    Circle(25,25, 18, $ff4400)
;Debug angle
    Line(25,25, 18*Cos(angle*#PI/180.0), 18*Sin(angle*#PI/180.0), $55ff00)
    ;Circle(20+Random(10),20+Random(10),10,$0000ff)
  StopDrawing()
  SetGadgetState(#IG_angle, ImageID(#Img_angle) )
EndProcedure


Procedure loadSet(fileParam$)
  old_file$=file$
  If fileParam$=""
    file$=OpenFileRequester("Load Set", ".\Parameter Sets\", "*.txt|*.txt", 0)
  Else
    file$=fileParam$
  EndIf
  
  If file$=""
    file$=old_file$
    ProcedureReturn
  ElseIf ReadFile(#file, file$)

    version=0
    s$=ReadString(#file);# get version
    If Left(s$,1)="#"
      version=Val( Mid(s$,2,Len(s$)-1) )
    Else
      FileSeek(#file,0)
    EndIf

    
    SetGadgetText(#S_xStart, ReadString(#file) )
    SetGadgetText(#S_yStart, ReadString(#file) )
    SetGadgetText(#S_rStart, ReadString(#file) )
    SetGadgetText(#S_tiefe,  ReadString(#file) )
      tiefe=Val( GetGadgetText(#S_tiefe) )
      ReDim tiefeVerlauf(tiefe)
      For i=0 To tiefe
        tiefeVerlauf(i)=1
      Next
      drawTiefeVerlauf()
      
    SetGadgetState(#C_zufall, Val(ReadString(#file)) )
    
    SetGadgetState(#C_A_use, Val(ReadString(#file)) )
    SetGadgetState(#C_B_use, Val(ReadString(#file)) )
    SetGadgetState(#C_C_use, Val(ReadString(#file)) )
    
    SetGadgetText(#S_A_alphaMult, ReadString(#file) )
    SetGadgetText(#S_B_alphaMult, ReadString(#file) )
    SetGadgetText(#S_C_alphaMult, ReadString(#file) )
    
    SetGadgetText(#S_A_alphaAdd, ReadString(#file) )
    SetGadgetText(#S_B_alphaAdd, ReadString(#file) )
    SetGadgetText(#S_C_alphaAdd, ReadString(#file) )
    
    SetGadgetText(#S_A_rMult, ReadString(#file) )
    SetGadgetText(#S_B_rMult, ReadString(#file) )
    SetGadgetText(#S_C_rMult, ReadString(#file) )
    
    SetGadgetText(#S_A_rAdd, ReadString(#file) )
    SetGadgetText(#S_B_rAdd, ReadString(#file) )
    SetGadgetText(#S_C_rAdd, ReadString(#file) )
    

    If version>1
    
      angle=ValD( ReadString(#file) )
      drawAngle()
      
      tiefe=Val( GetGadgetText(#S_tiefe) )
      ReDim tiefeVerlauf(tiefe)
      For i=0 To tiefe-1
        tiefeVerlauf(i)=Val( Chr(ReadCharacter(#file)) )
      Next
      ReadString(#file)
      drawTiefeVerlauf()
      
      bgColor=Val( ReadString(#file) )
      
    Else
      angle=0
      drawAngle()
      bgColor.l=$771133
    EndIf

    
    CloseFile(#file)
    SetWindowTitle(#Win, #WinTitle$+file$)
    StatusBarText(#StBr, 0, Str(getSegmentAmount())+" Segmente", #PB_StatusBar_Right)
  Else
    MessageRequester("error", "can't open file", #PB_MessageRequester_Cancel)
  EndIf
EndProcedure


Procedure saveSet()
  old_file$=file$
  Repeat
    file$=SaveFileRequester("Save Set", ".\Parameter Sets\", "*.txt|*.txt", 0)
    If file$=""
      file$=old_file$
      ProcedureReturn
    ElseIf ReadFile(#file, file$)
      CloseFile(#file)
      If MessageRequester("bitte besttigen", "'"+file$+"' existiert bereits."+Chr(10)+"Datei ersetzen?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
        ok=1
      EndIf
    Else
      ok=1
    EndIf
  Until ok
  
  If GetExtensionPart(file$)<>"txt"
    file$+".txt"
  EndIf
  
  If CreateFile(#file, file$)
  
    WriteStringN(#file, "#2");#version
  
    s$=GetGadgetText(#S_xStart)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_yStart)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_rStart)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_tiefe)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$  )
    
    s$=Str( GetGadgetState(#C_zufall) )
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    
    
    
    s$=Str( GetGadgetState(#C_A_use) )
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=Str( GetGadgetState(#C_B_use) )
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=Str( GetGadgetState(#C_C_use) )
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    
    
    
    s$=GetGadgetText(#S_A_alphaMult)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_B_alphaMult)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_C_alphaMult)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    
    
    
    s$=GetGadgetText(#S_A_alphaAdd)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_B_alphaAdd)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_C_alphaAdd)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    
    
    
    s$=GetGadgetText(#S_A_rMult)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_B_rMult)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_C_rMult)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    
    
    
    s$=GetGadgetText(#S_A_rAdd)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_B_rAdd)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    s$=GetGadgetText(#S_C_rAdd)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    
    
    ;#2 ------------------------
    s$=StrD( angle )
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    For i=0 To tiefe-1
      If tiefeVerlauf(i)
        WriteString(#file, "1" )
      Else
        WriteString(#file, "0" )
      EndIf
    Next
    WriteStringN(#file,"")
    
    s$=Str(bgColor)
    If s$="" : s$="0" : EndIf
    WriteStringN(#file, s$ )
    
    
    CloseFile(#file)
    SetWindowTitle(#Win, #WinTitle$+file$)
  Else
    MessageRequester("error", "can't save file", #PB_MessageRequester_Cancel)
  EndIf
EndProcedure


Procedure savePic()
  Repeat
    file$=SaveFileRequester("Save Picture", ".\Parameter Sets\", "*.bmp|*.bmp", 0)
    If file$=""
      ProcedureReturn
    ElseIf ReadFile(#file, file$)
      CloseFile(#file)
      If MessageRequester("bitte besttigen", "'"+file$+"' existiert bereits."+Chr(10)+"Datei ersetzen?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
        ok=1
      EndIf
    Else
      ok=1
    EndIf
  Until ok
  
  If GetExtensionPart(file$)<>"bmp" And GetExtensionPart(file$)<>"BMP"
    file$+".bmp"
  EndIf
  SaveImage(#img, file$)
EndProcedure


Procedure Open_win()
  hWin=OpenWindow(#Win, 10, 20, 950, 700, #WinTitle$,  #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered )
  If hWin=0 : MessageRequester("error", "openwindow() failed") : End
  EndIf
  CreateGadgetList(hWin)
    ImageGadget(#IG_img, 8,100, #iw,#ih, hImg, #PB_Image_Border)
    CreateStatusBar(#StBr, hWin)
      AddStatusBarField( 180 )
    ProgressBarGadget(#PrgBr, 185,WindowHeight(#Win)-18, 100,18, 0,100)
      SetGadgetColor(#PrgBr, #PB_Gadget_FrontColor, $ff3030)
    TextGadget(#T_watch, 217, 18, 30, 20, "watch ", #PB_Text_Right)
    CheckBoxGadget(#C_watch, 251, 15, 20, 20, "")
    
    ButtonGadget(#B_loadSet, 27, 13, 64, 20, "Load Set")
    ButtonGadget(#B_saveSet, 27, 38, 64, 20, "Save Set")
    ButtonGadget(#B_savePic, 27, 63, 64, 20, "Save Pic")
    TextGadget(#T_xStart, 113, 19, 40, 20, "x Start ", #PB_Text_Right)
    TextGadget(#T_yStart, 113, 44, 40, 20, "y Start ", #PB_Text_Right)
    TextGadget(#T_rStart, 113, 69, 40, 20, "r Start ", #PB_Text_Right)
    StringGadget(#S_xStart, 153, 15, 50, 20, "")
    StringGadget(#S_yStart, 153, 40, 50, 20, "")
    StringGadget(#S_rStart, 153, 65, 50, 20, "")
    TextGadget(#T_tiefe, 211, 42, 40, 20, "Tiefe ", #PB_Text_Right)
    StringGadget(#S_tiefe, 251, 40, 36, 20, "")
    TextGadget(#T_Zufall, 221, 70, 30, 20, "Zufall ", #PB_Text_Right)
    CheckBoxGadget(#C_zufall, 251, 67, 20, 20, "")
    TextGadget(#T_A_use, 326, 18, 74, 20, "A           use ", #PB_Text_Right)
    TextGadget(#T_B_use, 326, 42, 74, 20, "B           use ", #PB_Text_Right)
    TextGadget(#T_C_use, 326, 67, 74, 20, "C           use ", #PB_Text_Right)
    CheckBoxGadget(#C_A_use, 400, 15, 20, 20, "")
    CheckBoxGadget(#C_B_use, 400, 40, 20, 20, "")
    CheckBoxGadget(#C_C_use, 400, 65, 20, 20, "")
    TextGadget(#T_A_alphaMult, 460, 19, 40, 20, "alpha * ", #PB_Text_Right)
    TextGadget(#T_B_alphaMult, 460, 44, 40, 20, "alpha * ", #PB_Text_Right)
    TextGadget(#T_C_alphaMult, 460, 69, 40, 20, "alpha * ", #PB_Text_Right)
    StringGadget(#S_A_alphaMult, 505, 15, 50, 20, "")
    StringGadget(#S_B_alphaMult, 505, 40, 50, 20, "")
    StringGadget(#S_C_alphaMult, 505, 65, 50, 20, "")
    TextGadget(#T_A_alphaAdd, 577, 19, 40, 20, "alpha + ", #PB_Text_Right)
    TextGadget(#T_B_alphaAdd, 577, 44, 40, 20, "alpha + ", #PB_Text_Right)
    TextGadget(#T_C_alphaAdd, 577, 68, 40, 20, "alpha + ", #PB_Text_Right)
    StringGadget(#S_A_alphaAdd, 622, 15, 50, 20, "")
    StringGadget(#S_B_alphaAdd, 622, 40, 50, 20, "")
    StringGadget(#S_C_alphaAdd, 622, 65, 50, 20, "")
    TextGadget(#T_A_rMult, 692, 19, 40, 20, "r * ", #PB_Text_Right)
    TextGadget(#T_B_rMult, 692, 44, 40, 20, "r * ", #PB_Text_Right)
    TextGadget(#T_C_rMult, 692, 69, 40, 20, "r * ", #PB_Text_Right)
    StringGadget(#S_A_rMult, 737, 15, 50, 20, "")
    StringGadget(#S_B_rMult, 737, 40, 50, 20, "")
    StringGadget(#S_C_rMult, 737, 65, 50, 20, "")
    TextGadget(#T_A_rAdd, 797, 19, 40, 20, "r + ", #PB_Text_Right)
    TextGadget(#T_B_rAdd, 797, 44, 40, 20, "r + ", #PB_Text_Right)
    TextGadget(#T_C_rAdd, 797, 69, 40, 20, "r + ", #PB_Text_Right)
    StringGadget(#S_A_rAdd, 842, 15, 50, 20, "")
    StringGadget(#S_B_rAdd, 842, 40, 50, 20, "")
    StringGadget(#S_C_rAdd, 842, 65, 50, 20, "")
  
  AddKeyboardShortcut(#Win, #PB_Shortcut_Return, #ShCt_ret)
  AddKeyboardShortcut(#Win, #PB_Shortcut_Escape, #ShCt_esc)
  AddKeyboardShortcut(#Win, #PB_Shortcut_F1, #ShCt_f1)

  ;#######################
  
  #WinC_H
  hWinControl=OpenWindow(#WinControl, WindowX(#Win), 0, 950, #WinC_H, "CONTROL", #PB_Window_TitleBar, hWin)
  If hWinControl=0 : MessageRequester("error", "openwindow() failed") : End
  EndIf
  If CreateGadgetList(hWinControl)=0 : MessageRequester("error", "creategadgetlist() failed") : End
  EndIf
    ButtonGadget(#B_bgColor, 220,40, 154,20, "Hintergrundfarbe")
    If CreateImage(#Img_tiefeVerlauf, 300+3,20)
      ImageGadget(#IG_tiefeVerlauf, 70,10, 300+3,20, ImageID(#Img_tiefeVerlauf) )
    EndIf
    If CreateImage(#Img_angle, 50,50)
      ImageGadget(#IG_angle, 10,10, 50,50, ImageID(#Img_angle) )
    EndIf
    ButtonGadget(#B_setStartingPoint, 70,40, 145,20, "Startpunkt setzen...")
    
  HideWindow(#WinControl,1)

EndProcedure


Procedure userAction()
  Shared quit
  Event      =WaitWindowEvent(50)
  EventGadget=EventGadget()
  EventType  =EventType()
  EventMenu  =EventMenu()
  EventWindow=EventWindow()


  ;############################  CONTROL  ######
  DMX=DesktopMouseX()
  Control_X=WindowX(#Win)
  Control_W=WindowWidth(#Win)-560
  DMY=DesktopMouseY()
  If (DMX >= Control_X) And (DMX <= Control_X+Control_W)
    If control=0 And DMY<2
      control=1
      ResizeWindow(#WinControl, Control_X,0, Control_W,0)
      HideWindow(#WinControl,0)
      For i=0 To #WinC_H Step #speed
        ResizeWindow(#WinControl, Control_X,0, Control_W,i)
        Delay(2)
      Next
    EndIf
  ElseIf control=1
    For i=#WinC_H To 0 Step -2*#speed
      ResizeWindow(#WinControl, Control_X,0, Control_W,i)
      Delay(2)
    Next
    HideWindow(#WinControl,1)
    control=0
  EndIf
  If DMY>#WinC_H+30 And control=1
    For i=#WinC_H To 0 Step -2*#speed
      ResizeWindow(#WinControl, Control_X,0, Control_W,i)
      Delay(2)
    Next
    HideWindow(#WinControl,1)
    control=0
  EndIf
  ;#############################################


  
  ;##################
  If EventWindow=#Win
  ;##################
    Select Event
      Case #PB_Event_Menu
        Select EventMenu
          Case #ShCt_ret
            setSP=0
            SetGadgetAttribute(#PrgBr, #PB_ProgressBar_Maximum, getSegmentAmount() )
            SetGadgetState(#PrgBr, 0)
            checkedWatch=GetGadgetState(#C_watch)
            tiefenzaehler=0
            segmentzaehler=0
            rot=0
            gruen=0

            x.d=ValF( ReplaceString( GetGadgetText(#S_xStart), "," , "." ) )
            y.d=ValF( ReplaceString( GetGadgetText(#S_yStart), "," , "." ) )
            r.d=ValF( ReplaceString( GetGadgetText(#S_rStart), "," , "." ) )
            tiefe=Val( GetGadgetText(#S_tiefe) )

            checkedZufall=GetGadgetState(#C_zufall)
            
            checkedA=GetGadgetState(#C_A_use)
            checkedB=GetGadgetState(#C_B_use)
            checkedC=GetGadgetState(#C_C_use)
            
            A_alphaMult=ValF( ReplaceString( GetGadgetText(#S_A_alphaMult), "," , "." ) )
            B_alphaMult=ValF( ReplaceString( GetGadgetText(#S_B_alphaMult), "," , "." ) )
            C_alphaMult=ValF( ReplaceString( GetGadgetText(#S_C_alphaMult), "," , "." ) )
  
            A_alphaAdd=ValF( ReplaceString( GetGadgetText(#S_A_alphaAdd), "," , "." ) )
            B_alphaAdd=ValF( ReplaceString( GetGadgetText(#S_B_alphaAdd), "," , "." ) )
            C_alphaAdd=ValF( ReplaceString( GetGadgetText(#S_C_alphaAdd), "," , "." ) )
            
            A_rMult=ValF( ReplaceString( GetGadgetText(#S_A_rMult), "," , "." ) )
            B_rMult=ValF( ReplaceString( GetGadgetText(#S_B_rMult), "," , "." ) )
            C_rMult=ValF( ReplaceString( GetGadgetText(#S_C_rMult), "," , "." ) )
  
            A_rAdd=ValF( ReplaceString( GetGadgetText(#S_A_rAdd), "," , "." ) )
            B_rAdd=ValF( ReplaceString( GetGadgetText(#S_B_rAdd), "," , "." ) )
            C_rAdd=ValF( ReplaceString( GetGadgetText(#S_C_rAdd), "," , "." ) )
            
            StartDrawing( ImageOutput(#img) )
              Box(0,0, #iw,#ih,bgColor)
              frac(x, y, 90.0, r) ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< starting call
            StopDrawing()
            SetGadgetState(#IG_img, hImg)
            SetGadgetState(#PrgBr, 0)
            kill_recursion=0
          Case #ShCt_f1
            help()
        EndSelect
      Case #PB_Event_Gadget
        Select EventGadget
          Case #IG_img
            If setSP
              SetGadgetText( #S_xStart, Str(WindowMouseX(#Win)-GadgetX(#IG_img)) )
              SetGadgetText( #S_yStart, Str(WindowMouseY(#Win)-GadgetY(#IG_img)) )
              StartDrawing( ImageOutput(#img) )
                Circle( WindowMouseX(#Win)-GadgetX(#IG_img), WindowMouseY(#Win)-GadgetY(#IG_img), 4, $00ff00)
                Circle( WindowMouseX(#Win)-GadgetX(#IG_img), WindowMouseY(#Win)-GadgetY(#IG_img), 2, $0000ff)
              StopDrawing()
              SetGadgetState(#IG_img, ImageID(#img) )
              setSP=0
            EndIf
          Case #C_watch
            ;
          Case #B_loadSet
            loadSet("")
          Case #B_saveSet
            saveSet()
          Case #B_savePic
            savePic()
  ;       Case #S_xStart
  ;       Case #S_yStart
  ;       Case #S_rStart
          Case #S_tiefe
            StatusBarText(#StBr, 0, Str(getSegmentAmount())+" Segmente", #PB_StatusBar_Right)
            
            tiefeOld=tiefe
            tiefe=Val( GetGadgetText(#S_tiefe) )
            ReDim tiefeVerlauf(tiefe)
            For i=tiefeOld+1 To tiefe
              tiefeVerlauf(i)=1
            Next
            drawTiefeVerlauf()
            
  ;       Case #C_zufall
          Case #C_A_use
            StatusBarText(#StBr, 0, Str(getSegmentAmount())+" Segmente", #PB_StatusBar_Right)
          Case #C_B_use
            StatusBarText(#StBr, 0, Str(getSegmentAmount())+" Segmente", #PB_StatusBar_Right)
          Case #C_C_use
            StatusBarText(#StBr, 0, Str(getSegmentAmount())+" Segmente", #PB_StatusBar_Right)
  ;       Case #S_A_alphaMult
  ;       Case #S_B_alphaMult
  ;       Case #S_C_alphaMult
  ;       Case #S_A_alphaAdd
  ;       Case #S_B_alphaAdd
  ;       Case #S_C_alphaAdd
  ;       Case #S_A_rMult
  ;       Case #S_B_rMult
  ;       Case #S_C_rMult
  ;       Case #S_A_rAdd
  ;       Case #S_B_rAdd
  ;       Case #S_C_rAdd
          Default
            SetWindowTitle(#Win,  #WinTitle$+file$+" [modified]"  )
        EndSelect
      Case #PB_Event_CloseWindow
        quit=1
    EndSelect
  EndIf


    
  ;###########################  
  If EventWindow=#WinControl
  ;###########################
    Select Event
      Case #PB_Event_Menu
        Select EventMenu
        EndSelect
      Case #PB_Event_Gadget
        Select EventGadget
          Case #B_bgColor
            c=ColorRequester(bgColor)
            If c <> -1 : bgColor=c
            EndIf
          Case #IG_tiefeVerlauf
            If tiefe
              index= (WindowMouseX(#WinControl)-GadgetX(#IG_tiefeVerlauf))/(300/tiefe)
              If EventType=#PB_EventType_LeftClick
                tiefeVerlauf(index)=1
              ElseIf EventType=#PB_EventType_RightClick
                tiefeVerlauf(index )=0
              EndIf
              drawTiefeVerlauf()
            EndIf
          Case #IG_angle
            xd=WindowMouseX(#WinControl)-GadgetX(#IG_angle)-25
            yd=WindowMouseY(#WinControl)-GadgetY(#IG_angle)-25
            alphaM.d
            If xd>0 And yd>0 : alphaM=         ATan(Abs(yd)/Abs(xd)) : EndIf
            If xd>0 And yd<0 : alphaM= 2*#PI - ATan(Abs(yd)/Abs(xd)) : EndIf
            If xd<0 And yd>0 : alphaM=   #PI - ATan(Abs(yd)/Abs(xd)) : EndIf
            If xd<0 And yd<0 : alphaM=   #PI + ATan(Abs(yd)/Abs(xd)) : EndIf
            
            If xd=0 And yd>0 : alphaM=   #PI*0.5 : EndIf
            If xd=0 And yd<0 : alphaM=   #PI*1.5 : EndIf
            angle=alphaM*180.0/#PI
            drawAngle()
          Case #B_setStartingPoint
            For i=#WinC_H To 0 Step -2*#speed
              ResizeWindow(#WinControl, Control_X,0, Control_W,i)
            Next
            HideWindow(#WinControl,1)
            control=0
            setSP=1
            StartDrawing( ImageOutput(#img) )
              Circle( Val(GetGadgetText(#S_xStart)),Val(GetGadgetText(#S_yStart)), 4, $ffffff)
              Circle( Val(GetGadgetText(#S_xStart)),Val(GetGadgetText(#S_yStart)), 2, $0000ff)
            StopDrawing()
            SetGadgetState(#IG_img, ImageID(#img) )
        EndSelect
      Case #PB_Event_CloseWindow
        CloseWindow(#WinHelp)
    EndSelect
  EndIf


  
  ;#############################
  If EventWindow=#WinHelp And Event=#PB_Event_CloseWindow
    CloseWindow(#WinHelp)
  EndIf
  ;#############################
EndProcedure

; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 391
; Folding = Ay
; UseMainFile = fracMAIN.pb
; Executable = frac.exe
; HideErrorLog